import { EntityOptions, Metadata, ENTITY_WATERMARK, EntityMetadata, ENTITY_METADATA } from 'lib/common'

/**
 * Describe entities that are stored under the collection name.
 *
 * @param collectionName
 * @param entityOptions
 * @returns
 */
export const Entity =
    (collectionName: string, entityOptions: EntityOptions = {}) =>
    (constructor: object) => {
        Metadata.define(constructor, ENTITY_WATERMARK, true)
        Metadata.mergeDeep<EntityMetadata>(constructor, ENTITY_METADATA, {
            collectionName,
            entityOptions,
            entityColumns: []
        })
    }
